package de.uni_marburg.powersort.benchmark;

import de.uni_marburg.powersort.data.CglEnum;
import de.uni_marburg.powersort.data.DataEnum;
import de.uni_marburg.powersort.sort.SortEnum;
import org.openjdk.jmh.annotations.Benchmark;
import org.openjdk.jmh.annotations.Param;
import org.openjdk.jmh.annotations.Scope;
import org.openjdk.jmh.annotations.State;

/*
 * Benchmark state parameters
 *
 * Quote from JMH:
 * State objects naturally encapsulate the state on which benchmark is working on.
 */
@State(Scope.Benchmark)
public class JmhCgl extends JmhBase {
    // Either all or a selection of input lists.
    @Param()
    //@Param({"ASCENDING_RUNS", "ASCENDING_RUNS_WITH_OVERLAP", "MANY_ASCENDING_RUNS", "MANY_ASCENDING_RUNS_WITH_OVERLAP"})
    CglEnum dataEnum;

    // Either all or a selection of sort implementations.
    //@Param()
    @Param({"TIM_SORT", "FASTER_FINN_SORT", "IMPL_M_11", "IMPL_M_21"})
    SortEnum sortEnum;

    @Override
    DataEnum getDataEnum(){
        return dataEnum;
    }
    @Override
    SortEnum getSortEnum(){
        return sortEnum;
    }

    // We could move this method up to JmhBase to avoid redundancy in the subclasses.
    // But this would remove the run button of the IntelliJ plugin "JMH Java Microbenchmark Harness".
    // Furthermore, with this approach we don't need to exclude JmhBase as it has no benchmark methods.
    @Benchmark
    public void benchmark() {
        sortImpl.sort(workingCopy);
    }
}